# lib/rpmevr.h File Reference

Structure(s) and routine(s) used for EVR parsing and comparison. More...

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Defines

#define | RPMSENSE_SENSEMASK 0x0e
#define | RPMSENSE_NOTEQUAL (RPMSENSE_EQUAL ^ RPMSENSE_SENSEMASK)

## Typedefs

typedef struct EVR_s * | EVR_t
typedef enum evrFlags_e | evrFlags
| Dependency Attributes.
typedef enum evrFlags_e | rpmsenseFlags

## Enumerations

enum | evrFlags_e { RPMSENSE_LESS = (1 << 1), RPMSENSE_GREATER = (1 << 2), RPMSENSE_EQUAL = (1 << 3), RPMSENSE_PREREQ = (1 << 6) }
| Dependency Attributes. More...

## Functions

int | rpmEVRcmp (const char *a, const char *b)
| Segmented string compare.
int | rpmEVRparse (const char *evrstr, EVR_t evr)
| Split EVR string into epoch, version, and release components.
int | rpmEVRcompare (const EVR_t a, const EVR_t b)
| Compare EVR containers.
rpmsenseFlags | rpmEVRflags (const char *op, const char **end)
| Return comparison operator sense flags.

## Variables

int | _rpmevr_debug
int(* | rpmvercmp )(const char *a, const char *b)
| Segmented string compare vector.

## Detailed Description

Structure(s) and routine(s) used for EVR parsing and comparison.

Definition in file rpmevr.h.

## Define Documentation

#define RPMSENSE_NOTEQUAL (RPMSENSE_EQUAL ^ RPMSENSE_SENSEMASK)

Definition at line 76 of file rpmevr.h.

Referenced by init_rpm(), rpmdsCompare(), rpmdsNewDNEVR(), and unsatisfiedDepend().

#define RPMSENSE_SENSEMASK 0x0e

Definition at line 74 of file rpmevr.h.

Referenced by addReqProv(), depflagsFormat(), parseRCPOT(), rpmdsAnyMatchesDep(), rpmdsCompare(), rpmdsNewDNEVR(), rpmdsNVRMatchesDep(), triggercondsTag(), and unsatisfiedDepend().

## Typedef Documentation

typedef struct EVR_s* EVR_t

Definition at line 20 of file rpmevr.h.

typedef enum evrFlags_e evrFlags

Dependency Attributes.

typedef enum evrFlags_e rpmsenseFlags

Definition at line 72 of file rpmevr.h.

## Enumeration Type Documentation

enum evrFlags_e

Dependency Attributes.

Enumerator:

  RPMSENSE_LESS |
  RPMSENSE_GREATER |
  RPMSENSE_EQUAL |
  RPMSENSE_PREREQ | (obsolete).

Definition at line 26 of file rpmevr.h.

## Function Documentation

rpmsenseFlags rpmEVRflags | ( | const char * | op,
|  | const char ** | end |
| ) |  |  |

Return comparison operator sense flags.

Parameters:

  | op | operator string (NULL or "" uses RPMSENSE_EQUAL)
  | *end | pointer to 1st character after operator (or NULL)

Returns:
  sense flags

Definition at line 177 of file rpmevr.c.

References cops, EVRop_s::operator, RPMSENSE_EQUAL, and EVRop_s::sense.

Referenced by parseRCPOT(), rpmdsPipe(), and rpmdsSysinfoFile().

## Variable Documentation

int _rpmevr_debug

Definition at line 14 of file rpmevr.c.